DKPmanager = LibStub("AceAddon-3.0"):NewAddon("DKP Manager","AceComm-3.0","AceTimer-3.0","AceEvent-3.0","AceHook-3.0","AceSerializer-3.0");
local Log=LibStub("DKPlog-1.0");
local B=LibStub("AceAddon-3.0"):GetAddon("DKP Bidder");
local GRI=LibStub("GuildRosterInfo-1.0");

DKPmanagerDB={};
local A=DKPmanager;
local DB=DKPmanagerDB;
A.log=Log;
A.prefix="dkp_manager";
DB.log={};
A.bidTable={};
DB.biddingType="sh";
DB.minBid=0;
DB.zeroSum=true;
DB.broadcastBidderUpdate=false;
DB.silenceBidding=true;




A.ver="420 204";
A.isInRaidGroup=false;


-----------------------------
-------/------------
-------------------------------

function A:RAID_ROSTER_UPDATE()

	if not UnitInRaid("player") then
		if A.biddingInProgress then
			self:Print("Ending bidding becouse you left the raid group");
			self:StopBids();
		end;
		self.isInRaidGroup=false;
		B.view.adminFrame.view.startStopButton:Disable();
	elseif not self.isInRaidGroup then
		self.isInRaidGroup=true;

		B.view.adminFrame.view.startStopButton:Enable();
	end


end
function A:OnInitialize()
	self:CreateGUI();
	self:RegisterEvent("LOOT_OPENED");
	self:RegisterEvent("RAID_ROSTER_UPDATE");
	A.log:RegisterCallback("ActionComplete",self.SendChanges,self);
	A.log:RegisterCallback("ActionFailed",self.SendFailed,self);
	self:RegisterComm(B.prefix);
	self:RegisterComm("QDKP_ksqBid",A.OldCompatibility);--TODO: remove this in release

	self:SecureHook("LootFrame_Update");
	self:SecureHook("ChatEdit_InsertLink");
	table.insert(B.dropDownMenuTable,(#B.dropDownMenuTable-1),{
		notCheckable = 1,
		disabled=1,
		text="",
	});
	table.insert(B.dropDownMenuTable,(#B.dropDownMenuTable-1),{
		text = "DKP Manager",
		isTitle = 1,
		notCheckable = 1,
	});
	table.insert(B.dropDownMenuTable,(#B.dropDownMenuTable-1),{
		text = "Increase/Reduce DKP",
		func = function()
			local v=B.view.rosterFrame.view;
			local point=v.bidderList:GetSelected();
			if point~=nil then
				local text="Type the change amount for following players: "
				local onlyMains={};
				local sep="";
				local mains={};
				for i=1,#point do
						text=text..sep..point[i][1].data.name;
						table.insert(mains,point[i][1].data.name);
						sep=",";
				end
				text=text..".";

				if StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"]~=nil then table.wipe(StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"]); end;
				StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"] = {
					text = text,
					whileDead = true,
					enterClicksFirstButton=1,
					hideOnEscape = 1,
					hasEditBox=true,
					button1 = "Change amounts",
					button2 = "Cancel",
					EditBoxOnTextChanged = function (self, data)
						-- careful! 'self' here points to the editbox, not the dialog
						self:GetParent().button1:Enable()          -- self:GetParent() is the dialog
					end,
					EditBoxOnEnterPressed = function(self) StaticPopup_OnClick(self:GetParent(), 1) end,
					EditBoxOnEscapePressed = function(self) StaticPopup_OnClick(self:GetParent(), 2) end,
					OnShow = function (self, data)
						self.button1:Disable();
					end,
					OnAccept = function(self, data, data2)
						local number=self.editBox:GetNumber();
						if number then

							A:ChangeAmounts(number,mains);--/script for i=1,20 do LibStub("AceAddon-3.0"):GetAddon("DKP Bidder"):Transfer(10,{"Mogrhana"}); end
						end
					end,
					timeout = 0,

				}
				StaticPopup_Show("DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup");
			end
		end,
		notCheckable = 1,
	});
	table.insert(B.dropDownMenuTable,(#B.dropDownMenuTable-1),{
		text = "Set alts",
		func = function()
			local v=B.view.rosterFrame.view;
			local point=v.bidderList:GetSelected();
			local main=v.bidderList:GetLastSelected()[1].data.name;
			if point~=nil then
				local text="Following players will be marked as alts of "..main..": ";
				local sep="";
				local mains={};
				for i=1,#point do
					if main~=point[i][1].data.name then
						text=text..sep..point[i][1].data.name;
						table.insert(mains,point[i][1].data.name);
						sep=",";
					end
				end
				text=text..".";

				if StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"]~=nil then table.wipe(StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"]); end;
				StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"] = {
					text = text,
					whileDead = true,
					enterClicksFirstButton=1,
					hideOnEscape = 1,
					hasEditBox=false,
					button1 = "Accept",
					button2 = "Cancel",
					OnAccept = function(self, data, data2)
						A:Print("This operation may take a few second to update data and notes, please wait.");
						for i=1,#mains do
							A.log:SetAlt(main,mains[i]);
						end

					end,
					timeout = 0,

				}
				StaticPopup_Show("DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup");
			end
		end,
		notCheckable = 1,
	});
	table.insert(B.dropDownMenuTable,(#B.dropDownMenuTable-1),{
		text = "Set as main",
		func = function()
			local v=B.view.rosterFrame.view;
			local point=v.bidderList:GetSelected();
			if point~=nil then
				local text="Following players will be marked as mains: ";
				local sep="";
				local mains={};
				for i=1,#point do
					text=text..sep..point[i][1].data.name;
					table.insert(mains,point[i][1].data.name);
					sep=",";
				end
				text=text..".";

				if StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"]~=nil then table.wipe(StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"]); end;
				StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup"] = {
					text = text,
					whileDead = true,
					enterClicksFirstButton=1,
					hideOnEscape = 1,
					hasEditBox=false,
					button1 = "Accept",
					button2 = "Cancel",
					OnAccept = function(self, data, data2)
						A:Print("This operation may take a few second to update data and notes, please wait.");
						for i=1,#mains do
							A.log:SetAlt(mains[i],mains[i]);
						end

					end,
					timeout = 0,

				}
				StaticPopup_Show("DKPBidder_TitleDropDownMenu_ChangeDKPStaticPopup");
			end
		end,
		notCheckable = 1,
	});
	table.insert(B.dropDownMenuTable,(#B.dropDownMenuTable-1),{
		text = "Show log",
		func = function() B.view.logFrame:Show(); B.view.logFrame:UpdateList() end,
		notCheckable = 1,
	});
end
function A:ChangeAmounts(number,mains)
	if StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPReason"]~=nil then table.wipe(StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPReason"]); end;
	StaticPopupDialogs["DKPBidder_TitleDropDownMenu_ChangeDKPReason"] = {
		text = "What reason?",
		hasEditBox=true,
		button1 = "Change amounts",
		button2 = "Cancel",
		EditBoxOnTextChanged = function (self, data)
			self:GetParent().button1:Enable()
		end,
		EditBoxOnEnterPressed = function(self) StaticPopup_OnClick(self:GetParent(), 1) end,
		EditBoxOnEscapePressed = function(self) StaticPopup_OnClick(self:GetParent(), 2) end,
		OnShow = function (self, data)
			self.mains=mains;
			self.button1:Disable();

		end,
		OnAccept = function(self, data, data2)
			local reason=self.editBox:GetText();

			for i=1,#mains do
				--print(mains[i],number,reason);
				A.log:AddAction(mains[i],number,reason);
			end
		end,
		timeout = 0,
		whileDead = true,
		enterClicksFirstButton=true,
		hideOnEscape = true,
	}
	StaticPopup_Show("DKPBidder_TitleDropDownMenu_ChangeDKPReason");
end

function A:SetBiddingState(bidMaster)
	local v=B.view.adminFrame.view;

	if bidMaster then

		v.startStopButton:SetText("Stop bidding");
		A.biddingInProgress=true
	else
		v.awardButton:Disable();
		v.startStopButton:SetText("Start bidding");
		A.biddingInProgress=false
	end
end

function A:ChatEdit_InsertLink(link)
	if B.view.adminFrame:IsVisible() and link:find("|Hitem") then  B.view.adminFrame.view.itemLinkEditBox:SetText(link); end;
end
A.printedItems={};
function A:LOOT_OPENED()

	local method, partyMaster, raidMaster = GetLootMethod()
	local guid=UnitGUID("target")
	local target=UnitName("target");
	if raidMaster~=nil and GetRaidRosterInfo(raidMaster)==UnitName("player") and UnitInRaid("player") then
		if not A.printedItems[guid] then
			if guid then A.printedItems[guid]=true;
			else
				target="container";
				if GetRealZoneText()=="Firelands" then
					target="Ragnaros"
				end;
			end;
			local n=0;
			for i=1,GetNumLootItems() do
				if LootSlotIsItem(i) then
					local texture, item, quantity, quality, locked = GetLootSlotInfo(i)
					if quality>=GetLootThreshold() then
						n=n+1;
					end;
				end;
			end;

			if n>0 then
				SendChatMessage("<DKP-Manager> ".."Items dropped by "..target..":","RAID");
				for i=1,GetNumLootItems() do

					if LootSlotIsItem(i) then
						local texture, item, quantity, quality, locked = GetLootSlotInfo(i)
						if quality>=GetLootThreshold() then
							--print("getlootslotinfo",texture, item, quantity, quality, locked );
							SendChatMessage("<DKP-Manager> ".."* "..GetLootSlotLink(i),"RAID");
						end;
					end;
					--print("loot threshold",GetLootThreshold());
				end;
			end;
		end;
		self:LootFrame_Update()
	else
		for i=1,4 do B.view["lootButton"..i]:Hide(); end--TODO does this have to be called everytimne on loot opened? :/
	end;

end
function A:LootFrame_Update()
	for i=1,4 do
		local lootB=_G["LootButton"..tostring(i)]
		--print(lootB.quality);
		if lootB.quality and LootSlotIsItem(i) and lootB.quality>=GetLootThreshold() then
			B.view["lootButton"..i]:Show()
		else
			B.view["lootButton"..i]:Hide()
		end
	end
end


function A:Print(msg)
	DEFAULT_CHAT_FRAME:AddMessage(B.colors["grey"].."DKP - |r|CFF2459FFManager"..B.colors["grey"].."> "..B.colors["close"]..msg);
end


function A:OnEnable()
	DB=DKPmanagerDB;
	A.DB=DB;
	A.log:SetDB(DB.log);

	if DB.timerAmount==nil then DB.timerAmount=30; end;
	if DB.awardIfStopBidsOnTimeOut==nil then DB.awardIfStopBidsOnTimeOut=false; end;
	if DB.stopBidsOnTimeOut==nil then DB.stopBidsOnTimeOut=false; end;
	if DB.autoStartTimer==nil then DB.autoStartTimer=false; end;
	if DB.autoRestartTimer==nil then DB.autoRestartTimer=false; end;


	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("DKP Manager", "DKP Manager")
	--LibStub("AceConfigDialog-3.0"):SetDefaultSize("DKP Manager", 400, 250)
	self:Print(B.colors["red"]..A.ver..B.colors["close"].." version Loaded");





end

function A:OnDisable()

    -- Called when the addon is disabled
end

local myOptionsTable = {
  type = "group",
  args = {
	h0={
		name="Minimum bid",
		type="header",
		order=9,
	},
	minBid={
		name="",
		type = "input",
		order=10,
		pattern="%d+";
		usage="Minimum bid must be a number.";
		set = function(info,val) local a=tonumber(val);if a~=nil then DB.minBid=a;end; end,
		get = function(info) return tostring(DB.minBid);  end,
	},
	h1={
		name="Bidding type",
		type="header",
		order=11,
	},
	biddingType={
		name="Method",
		type="select",
		values={sh="Second Highest",norm="Normal"},
		desc = "Set's the way winner is going to be charged. If 'normal', then he will pay the highest value that he bid. With second highest, he will pay the second highest amount that was bid by another person.",
		set = function(info,val) DB.biddingType=val; end,
		get = function(info) return DB.biddingType;  end,
		order=12,
	},
	h2={
		name="Settings",
		type="header",
		order=13,
	},
	zeroSum={
		name="zero sum",
		type="toggle",
		desc = "Enables / disables zero sum dkp award.",
		set = function(info,val) DB.zeroSum = val end,
		get = function(info) return DB.zeroSum end,
		order=14,
	},
	silenceBid={
		name="silence bidding",
		type="toggle",
		desc = "Enables / disables silence bidding.",
		set = function(info,val) DB.silenceBidding = val end,
		get = function(info) return DB.silenceBidding end,
		order=15,
	},
	transferDkp={
		name="transfer dkp",
		type="toggle",
		desc = "Enables / disables possibility to transfer dkp by you.",
		set = function(info,val) DB.canTransferDKP = val end,
		get = function(info) return DB.canTransferDKP end,
		order=16,
	},
	h4={
		name="Dkp backup",
		type="header",
		order=17,
	},
	dkpBackup={
		name="Backup",
		type="execute",
		desc = "Backup dkp points.",
		func = function()
				DB.backupOfficerNotes={};
				for i,v in pairs(GRI:GetData()) do
					DB.backupOfficerNotes[i]=v["officerNote"];
				end;
				DB.backupTime=date("%c", time());
				A:Print("Officer notes with points have been saved at "..DB.backupTime..".");
			end,
		order=18,
	},
	dkpRestore={
		name="Restore",
		type="execute",
		desc = "Restore dkp points.",
		func = function()
				local total= GetNumGuildMembers();
				if StaticPopupDialogs["DKPBidder_TitleDropDownMenu_RestoreDKPStaticPopup"]~=nil then table.wipe(StaticPopupDialogs["DKPBidder_TitleDropDownMenu_RestoreDKPStaticPopup"]); end;
				StaticPopupDialogs["DKPBidder_TitleDropDownMenu_RestoreDKPStaticPopup"] = {
					text = "Are you sure you want to restore dkp points from "..DB.backupTime.."?",
					whileDead = true,
					enterClicksFirstButton=1,
					hideOnEscape = 1,
					hasEditBox=false,
					button1 = "Restore",
					button2 = "Cancel",
					OnAccept = function(self, data, data2)
						for i=1,total do
							local name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile = GetGuildRosterInfo(i)
							if DB.backupOfficerNotes[name] then
								GuildRosterSetOfficerNote(i,DB.backupOfficerNotes[name]);
							end
						end;

						A:Print("Officer notes with points have been restored from "..DB.backupTime.." backup.");
					end,
					timeout = 0,

				}
				StaticPopup_Show("DKPBidder_TitleDropDownMenu_RestoreDKPStaticPopup");







			end,
		order=19,
	},
	h5={
		name="List players addon version",
		type="header",
		order=20,
	},
	verGuildCheck={
		name="Guild",
		type="execute",
		desc = "Check guild.",
		func = function()
				A:AskForVersion("guild");
			end,
		order=21,
	},
	verRaidCheck={
		name="Raid",
		type="execute",
		desc = "Check raid.",
		func = function()
				A:AskForVersion("raid");
			end,
		order=22,
	},
	h6={
		name="Timer settings",
		type="header",
		order=23,
	},
	autoStartTimer={
		name="Auto-start",
		type="toggle",
		desc = "Start timer automaticly when bidding was started.",
		set = function(info,val) DB.autoStartTimer = val end,
		get = function(info) return DB.autoStartTimer end,
		order=24,
	},
	autoRestartTimer={
		name="Restart on bid",
		type="toggle",
		desc = "Restarts the timer when bid have been received.",
		set = function(info,val) DB.autoRestartTimer= val end,
		get = function(info) return DB.autoRestartTimer end,
		order=25,
	},
	stopBidsOnTimeOut={
		name="Auto-stop",
		type="toggle",
		desc = "Stop bidding when the timer has run out.",
		set = function(info,val) DB.stopBidsOnTimeOut = val end,
		get = function(info) return DB.stopBidsOnTimeOut end,
		order=26,
	},
	awardIfStopBidsOnTimeOut={
		name="Auto-award",
		type="toggle",
		desc = "Award player automaticly when the bidding was stoped by the timer.",
		set = function(info,val) DB.awardIfStopBidsOnTimeOut= val end,
		get = function(info) return DB.awardIfStopBidsOnTimeOut end,
		order=27,
	},
	timerAmount={
		name="Time for bidding:",
		type = "input",
		order=28,
		pattern="%d+";
		usage="Time must be a number.";
		set = function(info,val) local a=tonumber(val);if a~=nil then DB.timerAmount=a;end; end,
		get = function(info) return tostring(DB.timerAmount);  end,
	},


}}

LibStub("AceConfig-3.0"):RegisterOptionsTable("DKP Manager", myOptionsTable, {"dkpmanager", "dkpm"});

--/script DKPmanager:LaunchDecay(5)
function A:LaunchDecay(perc)

	local players=GRI:GetMainPlayers();
	for i=1,#players do

		local name=players[i];
		local net= GRI:GetNet(name);

		if net > 0 then
			local change=math.floor(net*perc/100);
			if (change > 0) then
				A.log:AddAction(name,-change,"Decay by "..perc.."%.");
			end
		end
	end;
	self:Print("LaunchDecay function run.");
end
